#include <amxmodx>
#include <amxmisc>
#include <zombieplague>
#include <sqlx>


//new g_iAmmoPacks[33]
new g_szAuth[33][36]

new g_szSQLTable[64], Handle:g_hSQLTuple, g_szQuery[256]

new g_cvar_starting

public plugin_init()
{
	register_plugin("[ZP] Ammo Bank", "1.0", "PomanoB")
	
	register_cvar("zp_bank_sql_host", "127.0.0.1")
	register_cvar("zp_bank_sql_user", "amxbans")
	register_cvar("zp_bank_sql_pass", "")
	register_cvar("zp_bank_sql_db", "amxbans")
	register_cvar("zp_bank_sql_type", "mysql")
	
	new cvTable = register_cvar("zp_bank_table", "zp_bank")

	
	get_pcvar_string(cvTable, g_szSQLTable, charsmax(g_szSQLTable))
	new host[32],user[32],password[32],db[32]
	get_cvar_string("zp_bank_sql_host",host,31)
	get_cvar_string("zp_bank_sql_user",user,31)
	get_cvar_string("zp_bank_sql_pass",password,31)
	get_cvar_string("zp_bank_sql_db",db,31)
	
	g_hSQLTuple = SQL_MakeDbTuple(host,user,password,db)
	
	new iError, szError[256]
	new Handle:hSQLConnection = SQL_Connect(g_hSQLTuple, iError, szError, charsmax(szError))
	if(hSQLConnection != Empty_Handle)
	{
		SQL_QueryAndIgnore(hSQLConnection,
			"CREATE TABLE IF NOT EXISTS `%s` (\
				`USER_KEY` varchar(32) NOT NULL default '', \
				`LAST_PLAY_DATE` timestamp(14) NOT NULL, \
				`AP` int(10) NOT NULL default '0' ,\
				`NAME` varchar(32) \
				, PRIMARY KEY  (`USER_KEY`) ) \
				TYPE=MyISAM \
				COMMENT='Zombie Plague ammo pack saving table'",
			g_szSQLTable )
		
		SQL_FreeHandle(hSQLConnection)
	}
	else
		log_amx("plugin_init(): SQL Error #%d - %s", iError, szError)

	
}
public plugin_cfg()
{
	g_cvar_starting = get_cvar_pointer("zp_starting_ammo_packs")
}

public plugin_end()
{
	if (g_hSQLTuple)
		SQL_FreeHandle(g_hSQLTuple)
}

public client_putinserver(id)
{
	static szAuth[36]
	get_user_ip(id, szAuth, charsmax(szAuth),1)
	copy(g_szAuth[id], charsmax(g_szAuth[]), szAuth)
	
	LoadClient(id, szAuth)	
}

public client_disconnect(id)
{	
	SaveClient(id,  g_szAuth[id])
	
	g_szAuth[id][0] = 0
}

LoadClient(id, szAuth[])
{
	formatex(g_szQuery, charsmax(g_szQuery),
		"SELECT `AP` FROM `%s` WHERE `USER_KEY` = '%s'", 
		g_szSQLTable, szAuth)

	new cData[37]
	cData[0] = id
	copy(cData[1], charsmax(cData)-1, szAuth)
	
	SQL_ThreadQuery(g_hSQLTuple, "LoadClient_QueryHandler", g_szQuery, cData, strlen(cData[1]))
}

public LoadClient_QueryHandler(iFailState, Handle:hQuery, szError[], iErrnum, cData[], iSize, Float:fQueueTime)
{
	if(iFailState != TQUERY_SUCCESS)
	{
		log_amx("LoadClient(): SQL Error #%d - %s", iErrnum, szError)
		return
	}
	
	new id = cData[0]
	static szAuth[36]
	copy(szAuth, charsmax(szAuth), cData[1])
	
	new iAmmoPacks = 0
	if(SQL_NumResults(hQuery))
		iAmmoPacks = SQL_ReadResult(hQuery, 0)
				
	zp_set_user_ammo_packs(id,iAmmoPacks ? iAmmoPacks : get_pcvar_num(g_cvar_starting))
}

SaveClient(id, szAuth[])
{
	new ammoc = zp_get_user_ammo_packs(id)
	new name[32]
	get_user_name(id,name,31)
	
	formatex(g_szQuery, charsmax(g_szQuery),
		"INSERT INTO `%s` SET `USER_KEY`='%s', `AP`='%d', `LAST_PLAY_DATE`=SYSDATE(), `NAME`='%s' ON DUPLICATE KEY UPDATE `AP`='%d', `LAST_PLAY_DATE`=SYSDATE(), `NAME`='%s'",
		g_szSQLTable, szAuth, ammoc, name, ammoc, name) 
		
	SQL_ThreadQuery(g_hSQLTuple, "SaveClient_QueryHandler", g_szQuery)
}

public SaveClient_QueryHandler(iFailState, Handle:hQuery, szError[], iErrnum, iData[], iSize, Float:fQueueTime)
{
	if(iFailState != TQUERY_SUCCESS)
		log_amx("SaveClient(): SQL Error #%d - %s", iErrnum, szError)
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1049\\ f0\\ fs16 \n\\ par }
*/
